/* Copyright 2004 Sun Microsystems, Inc.  All rights reserved.  You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at:
 http://developer.sun.com/berkeley_license.html
 $Id: PasswordStrategy.java,v 1.1 2005/05/17 05:23:51 gmurray71 Exp $ */

package com.sun.j2ee.blueprints.clientstate;

/**
 * This interface is used to indicate the strategy used to generate a
 * password for securing client-side state.
 *
 * @author Inderjeet Singh
 */
public interface PasswordStrategy {
    
    /** Generate a password that is a secret for the server. The password must 
     * survive server crashes, and must remain the same at least until the 
     * session dies. */
    public String getPassword();
}
