/* Copyright 2005 Sun Microsystems, Inc. All rights reserved. You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at: http://developer.sun.com/berkeley_license.html  
$Id: DateValidator.java,v 1.1 2005/03/08 22:08:46 gmurray71 Exp $ */

package com.sun.j2ee.blueprints.bpcatalog.validator;

import java.util.*;
import java.util.regex.*;

import javax.faces.FactoryFinder;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.application.FacesMessage;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import javax.faces.component.StateHolder;

import javax.faces.application.ApplicationFactory;
import javax.faces.application.Application;



/**
 *
 */

public class DateValidator implements Validator, StateHolder {


    public static final String DATE_INVALID_MESSAGE_ID =
        "DateInvalid";

    private String datePattern = null;
    private boolean transientValue = false;

    public DateValidator() {
        super();
    }


    public DateValidator(String datePattern) {
        super();
        this.datePattern = datePattern;
    }


    public String getDatePatern() {

        return datePattern;
    }


    public void setDatePattern(String datePattern) {
        this.datePattern = datePattern;
    }
    
    public void validate(FacesContext context, UIComponent component, 
			 Object inputValue) {    
        
        boolean valid = false;
        String value = (String)inputValue;
        try {
            valid = Pattern.matches(datePattern, value);
        } catch(PatternSyntaxException pse) {
           System.out.println("Date:Validator: There is a problem with the regular expression!");
        }
        if (!valid) {
            FacesMessage error = new FacesMessage("Date " + value +
                            " is invalid. Please enter a date conforming to " +
                             datePattern);
            throw new ValidatorException(error);
        }
    }
    
    
    public Object saveState(FacesContext context) {
        Object values[] = new Object[1];
        values[0] = datePattern;
        return (values);
    }


    public void restoreState(FacesContext context, Object state) {
        Object values[] = (Object[]) state;
        datePattern = (String) values[0];
    }


    public boolean isTransient() {
        return (this.transientValue);
    }


    public void setTransient(boolean transientValue) {
        this.transientValue = transientValue;
    }
}
