/* Copyright 2004-2005 Sun Microsystems, Inc.  All rights reserved.  You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at: http://developer.sun.com/berkeley_license.html
$Id: BaseRenderer.java,v 1.2 2005/03/23 14:49:21 jenniferb Exp $  */

package com.sun.j2ee.blueprints.catalog.validator;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.render.Renderer;

import java.io.IOException;
import java.util.Iterator;
import java.util.MissingResourceException;
import java.util.ResourceBundle;


/**

 * <p>Convenient base class for <code>Renderer</code> implementations.</p>

 */

public abstract class BaseRenderer extends Renderer {


    public static final String BUNDLE_ATTR = "com.sun.faces.bundle";

    /**
     * Converts the component-generated client ID to a for suitable for
     * transmission to the client.
     * @param context the current <code>FacesContext</code> instance
     * @param clientId the component's client ID
     */
    public String convertClientId(FacesContext context, String clientId) {
        return clientId;
    }

}

