/* Copyright 2004-2005 Sun Microsystems, Inc.  All rights reserved.  You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at: http://developer.sun.com/berkeley_license.html
$Id: ColorRenderer.java,v 1.3 2005/03/23 14:49:22 jenniferb Exp $  */

package com.sun.j2ee.blueprints.catalog.validator;

import javax.faces.component.*;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import java.io.IOException;


/**
 * This class renders JavaScript
 */



public class ColorRenderer extends BaseRenderer {


    // -------------------------------------------------------- Renderer Methods

    /**
     * <p>No decoding is required.</p>
     *
     * @param context   <code>FacesContext</code>for the current request
     * @param component <code>UIComponent</code> to be decoded
     */

    public void decode(FacesContext context, UIComponent component) {

        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
    }

    /**
     * <p>No begin encoding is required.</p>
     *
     * @param context   <code>FacesContext</code>for the current request
     * @param component <code>UIComponent</code> to be decoded
     */
    public void encodeBegin(FacesContext context, UIComponent component)
        throws IOException {

        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }
    }

    /**
     * <p>No children encoding is required.</p>
     *
     * @param context   <code>FacesContext</code>for the current request
     * @param component <code>UIComponent</code> to be decoded
     */
    public void encodeChildren(FacesContext context, UIComponent component)
        throws IOException {

        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }

    }

    /**
     * <p>Encodes this component.</p>
     *
     * @param context   <code>FacesContext</code>for the current request
     * @param component <code>UIComponent</code> to be decoded
     */
    public void encodeEnd(FacesContext context, UIComponent component)
        throws IOException {

        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }

        UIOutput script = (UIOutput) component;
        UIInput currentColor = (UIInput) component.findComponent("color");
        ResponseWriter writer = context.getResponseWriter();

        StringBuffer sb = null;
        System.out.println("currentColor =" + currentColor);
        if (currentColor == null) return;
        sb = new StringBuffer("function client_validation() {\n");
        sb.append("if (document.forms[0]['");
        sb.append(currentColor.getClientId(context));
        sb.append("'].value=='red' ) {").append("\n");
        sb.append("return true;");
        sb.append("\n} else if (document.forms[0]['");
        sb.append(currentColor.getClientId(context));
    	sb.append("'].value=='green' ) {").append("\n");
        sb.append("return true;");
    	sb.append("\n} else if (document.forms[0]['");
        sb.append(currentColor.getClientId(context));
    	sb.append("'].value=='blue' ) {").append("\n");
        sb.append("return true;");
    	sb.append("\n } else {\n");
        sb.append("alert('Enter red, green, or blue for the color.');");
        sb.append("\nreturn false;\n");
	sb.append("} \n }");
        sb.append("\n");       
	
        if (writer != null) {
            writer.startElement("script", script);
            writer.writeAttribute("language", "JavaScript", "script");
            writer.write(sb.toString());
            writer.endElement("script");
        }
    }

}

