/* Copyright 2004-2005 Sun Microsystems, Inc.  All rights reserved.  You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at: http://developer.sun.com/berkeley_license.html
$Id: ColorValidator.java,v 1.3 2005/03/23 14:49:22 jenniferb Exp $  */

package com.sun.j2ee.blueprints.catalog.validator;

import javax.faces.FactoryFinder;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.application.FacesMessage;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import javax.faces.component.StateHolder;
import javax.faces.application.ApplicationFactory;
import javax.faces.application.Application;


/**
 Checks if the user's input is either "red", "green", or "blue".
*/



public class ColorValidator implements Validator {

    /**
     * <p>The message identifier of the message to be created if
     * the validation fails.</p>
     */

    public static final String COLOR_INVALID_MESSAGE_ID =
        "ColorInvalid";

    /**
     * Constructs a <code>ColorValidator</code>.
     */
    public ColorValidator() {
        super();
    }

    /**
     * Checks if the value of the specified component is "red", "green", or "blue".
     * @param context The current <code>FacesContext</code> instance
     * @param component The UI component whose value is to be validated
     * @param toValidate The value that is to be validated
     */
    public void validate(FacesContext context, UIComponent component, 
			 Object toValidate) {
        String value = null;
        if ((context == null) || (component == null)) {
            throw new NullPointerException();
        }

        if (!(component instanceof UIInput)) {
            return;
        }    

        if ( null == toValidate) {
	    return;
	}

       	value = toValidate.toString();
	if (value.equals("red") || value.equals("green") || value.equals("blue")) {
		return;
	} else {
            System.out.println("value "+value);
	    FacesMessage errMsg = MessageFactory.getMessage(context, 
							    COLOR_INVALID_MESSAGE_ID);
	    throw new ValidatorException(errMsg);
	}
    }

}

