/* Copyright 2004-2005 Sun Microsystems, Inc.  All rights reserved.  You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at: http://developer.sun.com/berkeley_license.html
$Id: ScriptTag.java,v 1.2 2005/03/23 14:49:22 jenniferb Exp $  */
 

package com.sun.j2ee.blueprints.catalog.validator;

import javax.faces.component.UIComponent;
import javax.faces.component.UIOutput;
import javax.faces.webapp.UIComponentTag;


/**
 * <p>This class is the tag handler class for a <code>UIOutput</code>
 * component associated with a <code>ColorRenderer</code> renderer.  The tag that this
 * class processes renders a script tag.</p>
 */

public class ScriptTag extends UIComponentTag {

    private String language = null;


    public void setLanguage(String language) {
        this.language = language;
    }

    /**
     * Gets the type of the component associated wit hthe tag.
     * @return the name of the component type
     */
    public String getComponentType() {
        return ("javax.faces.Output");
    }

    /**
     * Gets the type of the renderer that will render this tag.
     * @return the type of the renderer that renders this tag
     */
    public String getRendererType() {
        return ("Color");
    }


    /**
     * Releases resources allocated during the execution of this tag handler.
     */
    public void release() {
        super.release();
        this.language = null;
    }

    /**
     * Sets the properties of the specified component.
     * @param component the component associated with this tag
     */
    protected void setProperties(UIComponent component) {
	    super.setProperties(component);
    }

}

