/* Copyright 2004 Sun Microsystems, Inc.  All rights reserved.  You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at: 
 http://adventurebuilder.dev.java.net/LICENSE.txt
 $Id: WordServlet.java,v 1.2 2005/04/20 21:01:54 gmurray71 Exp $ */

package com.sun.j2ee.blueprints.clientstate;


import java.io.*;
import java.util.*;

// Apache Commons- Tag-Lib Imports
import org.apache.commons.codec.base64.Base64;

// J2EE imports 
import javax.servlet.*;
import javax.servlet.http.*;

import com.sun.j2ee.blueprints.clientstate.deserialize.*;

/**
 * This Servlet will modify the contents of the SampleBean.
 *
*/
public class WordServlet extends HttpServlet {

    private ServletContext context = null;
    
    public void init(ServletConfig config) throws ServletException {
        this.context = config.getServletContext();
    }
    
    public void doPost(HttpServletRequest request,
                            HttpServletResponse response) 
                               throws IOException, ServletException {
        // deserialize any state that might be in the page
        ClientStateDeserializer.deserialize(request,response);
        SampleBean bean = (SampleBean)request.getAttribute("sampleBean");
        if (bean == null) {
            System.out.println("WordServlet: Creating a new SampleBean");
            bean = new SampleBean();
            request.setAttribute("sampleBean", bean);
        }
        String newWord = request.getParameter("newWord");
        if (!newWord.trim().equals("")) {
                bean.addWord(newWord);
        }
        // remove words that are checked
        Map params = (Map)request.getParameterMap();
        Iterator it = params.keySet().iterator();
        while (it.hasNext()) {
            String key = (String)it.next();
            if (key.startsWith("word_")) {
                String[] values = (String[])params.get(key);
                String valueString = values[0];
                bean.removeWord(valueString);
            }
        }
        context.getRequestDispatcher("/index.jsp").forward(request, response);
    }
}

