/* Copyright 2005 Sun Microsystems, Inc.  All rights reserved.  You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at:
 http://developer.sun.com/berkeley_license.html
 $Id: SchemaDefinedPurchaseOrderServiceBean.java,v 1.10 2005/12/01 20:54:04 yutayoshida Exp $ */

package com.sun.j2ee.blueprints.objectposervice;

import java.rmi.*;
import javax.ejb.*;

/**
 * A simple endpoint that receives  PO objects
 * and returns the po ID
 */

public class SchemaDefinedPurchaseOrderServiceBean implements SessionBean {
    
    private SessionContext sc;
    public SchemaDefinedPurchaseOrderServiceBean(){}
    
    public String submitPO(PurchaseOrder po) throws InvalidPOException, RemoteException {
        //this is done just to illustrate throwing an application specific exception
        if(po.getPoId().equals("100"))
            throw new InvalidPOException("Invalid ID for the purchase order!!! " +
                    "For demo purposes, we throw " +
                    "an application defined exception for the ID value of 100.");
        
        //extract the PO ID and return to the client
        return po.getPoId();
    }
    
    //life cycle methods
    public void ejbCreate() throws CreateException {}
    
    public void setSessionContext(SessionContext sc) {
        this.sc = sc;
    }
    
    public void ejbRemove(){}
    
    public void ejbActivate() {}
    
    public void ejbPassivate() {}
}

