/* Copyright 2004 Sun Microsystems, Inc.  All rights reserved.  You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at:
 http://developer.sun.com/berkeley_license.html
 $Id: CommandSubmissionsBean.java,v 1.6 2005/03/26 10:06:43 inder Exp $ */

package com.sun.j2ee.blueprints.web;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.application.FacesMessage;
import javax.faces.validator.ValidatorException;
import javax.faces.event.*;

/**
 * Backing bean for the command submission application
 * @author Inderjeet Singh
 */
public class CommandSubmissionsBean {
    
    private static final String SUCCESS = "success";
    private static final String FAILURE = "failure";
    private static final String AUTHORISED_USER = "Authorised User";
    private static final String GUEST_USER = "Guest User";
    
    public CommandSubmissionsBean() {}
    
    /** matching property for the commandsubmissions:userName input field */
    public void setUserName(String userName) {
        this.userName = userName;
    }
    public String getUserName() {
        return userName;
    }
    private String userName = null;
    
    /** matching property for the commandsubmissions:password input field  */
    public void setPassword(String password) {
        this.password = password;
    }
    public String getPassword() {
        return password;
    }
    private String password = null;
    
    /** matching property for the commandsubmissions:allowedUserName input field */
    public void setAllowedUserName(String allowedUserName) {
        this.allowedUserName = allowedUserName;
    }
    public String getAllowedUserName() {
        return allowedUserName;
    }
    private String allowedUserName = null;
    
    /** matching property for the commandsubmissions:allowedPassword input field  */
    public void setAllowedPassword(String allowedPassword) {
        this.allowedPassword = allowedPassword;
    }
    public String getAllowedPassword() {
        return allowedPassword;
    }
    private String allowedPassword = null;
    
    /** matching property for the commandsubmissions:authStatus input field  */
    public void setAuthStatus(String authStatus) {
        this.authStatus = authStatus;
    }
    public String getAuthStatus() {
        return authStatus;
    }
    private String authStatus = null;
    
    public void setAuthType(String authType) {
        this.authType = authType;
    }
    public String getAuthType() {
        return authType;
    }
    private String authType = null;
    
    public String login() {
        String outcome = getUserName().equals(getAllowedUserName()) && getPassword().equals(getAllowedPassword()) ? SUCCESS : FAILURE;
        if (outcome.equals(SUCCESS)) {
            authStatus = "Login Succeeded";
            authType = AUTHORISED_USER;
        } else {
            authStatus = "Login Failed";
            authType = GUEST_USER;
        }
        return outcome;
    }
    
    /** This action listener method is called by JSF when the
     * "Show More Details/Hide Details" button is pressed */
    public void detailsActionListener(ActionEvent ae) {
        UIComponent src = ae.getComponent();
        UIComponent addrText = src.findComponent("commandsubmissions:addressText");
        UIComponent addrTextArea = src.findComponent("commandsubmissions:addressTextArea");
        String value = (String) src.getAttributes().get("value");
        if (value.equals("Show More Details")) {
            src.getAttributes().put("value", "Hide Details");
            if (addrText != null)
                addrText.setRendered(true);
            if (addrTextArea != null)
                addrTextArea.setRendered(true);
        } else if (value.equals("Hide Details")) {
            if (addrText != null)
                addrText.setRendered(false);
            if (addrTextArea != null)
                addrTextArea.setRendered(false);
            src.getAttributes().put("value", "Show More Details");
        } else {
            throw new RuntimeException("Unexpected value for button");
        }
    }
}

