/* Copyright 2005 Sun Microsystems, Inc. All rights reserved. You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at: http://developer.sun.com/berkeley_license.html
 */
package com.sun.javaee.blueprints.autocomplete;


/**
 * This bean carries session state, such as the address entered by the user
 *
 * @author Tor Norbye
 * @author Mark Basler
 */
public class SessionBean {
    private String name;
    private String street;
    private String city;
    private String state;
    private String zip;
    private final boolean bDebug=false;
    
    public SessionBean() {
    }

    public void setName(String name) {
        if(bDebug) System.out.println("Setting name - " + name);
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setStreet(String street) {
        if(bDebug) System.out.println("Setting street - " + street);
        this.street = street;
    }

    public String getStreet() {
        return street;
    }

    public void setCity(String city) {
        if(bDebug) System.out.println("Setting City - " + city);
        this.city = city;
    }

    public String getCity() {
        return city;
    }

    public void setState(String state) {
        if(bDebug) System.out.println("Setting state - " + state);
        this.state = state;
    }

    public String getState() {
        return state;
    }

    public void setZip(String zip) {
        if(bDebug) System.out.println("Setting zip - " + zip);
        this.zip = zip;
    }

    public String getZip() {
        return zip;
    }
}
