/*
 * Copyright 2006 Sun Microsystems, Inc. All rights reserved. You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at:
 * http://developer.sun.com/berkeley_license.html
 * $Id: Item.java,v 1.1 2006/06/21 01:12:06 inder Exp $
 */

package com.sun.javaee.blueprints.autoid.model;

import javax.persistence.*;

@Entity
        
public class Item implements java.io.Serializable {    
    
    private int itemID;
    private String name;
    private String description;
    private float listPrice;
    private float unitCost;
    
    public Item() { }
    
    @TableGenerator(name="ID_GEN",
            table="ID_GEN",
            pkColumnName="GEN_KEY",
            valueColumnName="GEN_VALUE",
            pkColumnValue="ITEM_ID",
            allocationSize=1)
    @GeneratedValue(strategy=GenerationType.TABLE,generator="ID_GEN")
    @Id
    public int getItemID() {
        return itemID;
    }
    
    public String getName() {
        return name;
    }
    
    public String getDescription() {
        return description;
    }
    
    public float getListPrice() {
        return listPrice;
    }
    
    public float getUnitCost() {
        return unitCost;
    }    
    public void setItemID(int itemID) {
        this.itemID = itemID;
    }
    public void setName(String name) {
        this.name = name;
    }
    public void setDescription(String description) {
        this.description = description;
    }

    public void setListPrice(float listPrice) {
        this.listPrice = listPrice;
    }
    public void setUnitCost(float unitCost) {
        this.unitCost = unitCost;
    }
}



