/* 
* Copyright 2006 Sun Microsystems, Inc. All rights reserved. You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at:
* http://developer.sun.com/berkeley_license.html
* $Id: CompAServlet.java,v 1.3 2006/06/23 17:05:41 basler Exp $ 
*/ 
/*
 * CompAServlet.java
 *
 * Created on June 19, 2006, 10:28 AM
 */

package com.sun.javaee.blueprints.components.ui.example;

import java.io.*;
import java.net.*;

import javax.servlet.*;
import javax.servlet.http.*;

/**
 *
 * @author basler
 * @version
 */
public class CompAServlet extends HttpServlet {
    
    /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/xml;charset=UTF-8");
        PrintWriter out = response.getWriter();
        String itemId=request.getParameter("itemId");
        
        response.setHeader("Pragma", "No-Cache");
        response.setHeader("Cache-Control", "no-cache,no-store,max-age=0");
        response.setDateHeader("Expires", 1);
        if(itemId != null) {
            out.println("<response>");
            if(itemId.indexOf("test1") > -1) {
                out.println("<title><![CDATA[" + itemId + " Lookup]]></title>");
                out.println("<message><![CDATA[<b>The itemId that is performing this lookup is '" + itemId +
                        "'.</b><br/><br/>This popup is trigger through the onmouseover and onmouseout event handlers.  " +
                        "Since this popup request is fulfilled using a <b>Servlet</b>, there is an initial pause on the first request to load the class.]]></message>");
            } else {
                out.println("<title><![CDATA[" + itemId + " Lookup]]></title>");
                out.println("<message><![CDATA[<b>The itemId that is performing this lookup is '" + itemId +
                        "'.</b><br/><br/>This popup is trigger through the onmouseover event handler and hidden when the user clicks on the 'CLOSE' link in the popup." +
                        "Since this popup request is fulfilled using a <b>Servlet</b>, there is an initial pause on the first request to load the class." +
                        "<br/><br/><span onclick=\"bpui.compA.hidePopup('pop1')\" style=\"z-index: 4; position: relative; cursor: pointer\"><b>[<u>CLOSE</u>]</b></span>" +
                        "]]></message>");
            }
            out.println("</response>");
        } else {
            out.println("<response>");
            out.println("<title><![CDATA[REQUEST ERROR]]></title>");
            out.println("<message><![CDATA[The query parameter 'itemId' required]]></message>");
            out.println("</response>");
        }
        out.flush();
        out.close();
    }
    
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /** Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /** Returns a short description of the servlet.
     */
    public String getServletInfo() {
        return "Short description";
    }
    // </editor-fold>
}
