/* 
* Copyright 2006 Sun Microsystems, Inc. All rights reserved. You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at:
* http://developer.sun.com/berkeley_license.html
* $Id: CompATag.java,v 1.2 2006/06/23 17:05:41 basler Exp $ 
*/ 
/*
 * CompATag.java
 *
 * Created on April 28, 2006, 7:48 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.sun.javaee.blueprints.components.ui.example;

import javax.servlet.jsp.tagext.*;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.JspException;

import javax.faces.component.UIComponent;
import javax.faces.component.UIOutput;
import javax.faces.webapp.UIComponentELTag;
import javax.faces.application.Application;
import javax.faces.application.ApplicationFactory;
import javax.faces.FactoryFinder;
import javax.el.ValueExpression;
import javax.faces.component.html.HtmlInputTextarea;

/**
 * This tag is the glue between the JSF tag and the renderer and JSF Component
 *
 * @author  basler
 */

public class CompATag extends UIComponentELTag {
    
    private ValueExpression style=null, styleClass=null, url=null;
    private String id=null;
    
    public String getComponentType() {
        return ("javax.faces.Output");
    }
    
    public String getRendererType() {
        return ("CompA");
    }

    public void setStyle(ValueExpression style) {
        this.style=style;
    }
    public ValueExpression getStyle() {
        return this.style;
    }

    public void setStyleClass(ValueExpression styleClass) {
        this.styleClass=styleClass;
    }
    public ValueExpression getStyleClass() {
        return this.styleClass;
    }

    public void setUrl(ValueExpression url) {
        this.url=url;
    }
    public ValueExpression getUrl() {
        return this.url;
    }
    
    

    /**
     * This method takes the properties from the JSP and populates the UIOutput components properties
     * for use in the RichTextEditorRenderer
     */
    protected void setProperties(UIComponent component) {
        super.setProperties(component);

        UIOutput outComp = (UIOutput)component;
        
        // pull out style attribute
        if (style != null) {
            if (!style.isLiteralText()) {
                outComp.setValueExpression("style", style);
            } else {
                outComp.getAttributes().put("style", style.getExpressionString());
            }
        }        
        
        // pull out styleClass attribute
        if (styleClass != null) {
            if (!styleClass.isLiteralText()) {
                outComp.setValueExpression("styleClass", styleClass);
            } else {
                outComp.getAttributes().put("styleClass", styleClass.getExpressionString());
            }
        }        
        
        // pull out url attribute
        if (url != null) {
            if (!url.isLiteralText()) {
                outComp.setValueExpression("url", url);
            } else {
                outComp.getAttributes().put("url", url.getExpressionString());
            }
        }        
        
    }
}




