/*
 * Copyright 2006 Sun Microsystems, Inc. All rights reserved. You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at:
 * http://developer.sun.com/berkeley_license.html
 * $Id: FileUploadCustomBean.java,v 1.3 2007/03/02 23:56:11 basler Exp $
 */
package com.sun.javaee.blueprints.fileupload;

import java.util.Hashtable;
import java.io.IOException;

import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.apache.shale.remoting.faces.ResponseFactory;

import com.sun.javaee.blueprints.components.ui.fileupload.FileUploadStatus;
import java.io.File;

/*
 * FileUploadCustomBean.java
 *
 * Created on February 8, 2006, 6:11 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author basler
 */
public class FileUploadCustomBean {
    
    private boolean bDebug=false;
    /**
     * <p>Factory for response writers that we can use to construct the
     * outgoing response.</p>
     */
    private static ResponseFactory factory = new ResponseFactory();
    
    
    /** Creates a new instance of FileUploadCustomBean */
    public FileUploadCustomBean() {
    }
    
    public void postProcessingMethod(FacesContext context, Hashtable htUpload, FileUploadStatus status) {
        if(bDebug) System.out.println("IN Custom Post Processing method");
        // if parameter set don't keep upload.  This is for the live application, so uploads don't permenantly persist
        String persist_image=context.getExternalContext().getInitParameter("com.sun.blueprints.persist_image");
        if(persist_image.equals("false")) {
            // remove image after it is uploaded
            String logMessage="";
            for (Object key1 : htUpload.keySet()) {
                String key = key1.toString();
                if(key.startsWith("fileLocation_")) {
                    // delete file
                    try {
                        String fileLocation=(String)htUpload.get(key);
                        logMessage +=fileLocation + ", ";
                        new File(fileLocation).delete();
                    } catch(Exception e) {
                        e.printStackTrace();
                    }
                }
            }
            if(!logMessage.equals("")) {
                System.out.println("Web.xml set to delete file after upload, so Deleting file(s) - " + logMessage);
            }
        }
        
        
        try {
            // set custom return enabled so Phaselistener knows not to send default response
            status.enableCustomReturn();
            StringBuffer sb=new StringBuffer();
            
            // Acquire a response containing these results
            ResponseWriter writer = factory.getResponseWriter(context, "text/xml");
            writer.startElement("response", null);
            writer.startElement("message", null);
            writer.write("***CUSTOM SERVER-SIDE RETURN *** MESSAGE->");
            writer.write(status.getMessage());
            writer.endElement("message");
            
            writer.startElement("status", null);
            writer.write(status.getStatus());
            writer.endElement("status");
            
            writer.startElement("duration", null);
            writer.write(String.valueOf(status.getUploadTime()));
            writer.endElement("duration");
            
            writer.startElement("duration_string", null);
            writer.write(status.getUploadTimeString());
            writer.endElement("duration_string");
            
            writer.startElement("start_date", null);
            writer.write(status.getStartUploadDate().toString());
            writer.endElement("start_date");
            
            writer.startElement("end_date", null);
            writer.write(status.getEndUploadDate().toString());
            writer.endElement("end_date");
            
            writer.startElement("upload_size", null);
            writer.write(String.valueOf(status.getTotalUploadSize()));
            writer.endElement("upload_size");
            writer.endElement("response");
            writer.flush();
            
        } catch (IOException iox) {
            System.out.println("FileUploadPhaseListener error writting AJAX response : " + iox);
        }
        
    }
    
}
