/* 
* Copyright 2006 Sun Microsystems, Inc. All rights reserved. You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at:
* http://developer.sun.com/berkeley_license.html
* $Id: DetailServlet.java,v 1.1 2006/06/20 00:09:14 inder Exp $ 
*/ 
/*
 * DetailServlet.java
 *
 * Created on October 5, 2005, 11:32 AM
 */

package com.sun.javaee.blueprints.popup;

import java.io.*;
import java.net.*;

import javax.servlet.*;
import javax.servlet.http.*;

/**
 *
 * @author basler
 * @version
 */
public class DetailServlet extends HttpServlet {
    
    /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/xml");
        PrintWriter out = response.getWriter();
        
        // Get info for stock pick
        String codex=request.getParameter("animalcode");
        if(codex == null) {
            codex="LAB";
        }
        String name="Labrador Retriever";
        String descr="A breed of dog originating in Newfoundland, having a short coat and a tapering tail.";
        String imagex="dog1.gif";
        String lookup="labrador%20retriever";
        
        if(codex.equals("BULL")) {
            name="Bulldog";
            descr="A breed of short-haired dog characterized by a large head, strong square jaws with dewlaps, and a stocky body.";
            imagex="dog2.gif";
            lookup="bulldog";
                    
        } else if(codex.equals("BASSET")) {
            name="Basset Hound";
            descr="A short-haired hunting dog originating in France and having a long body, short legs, and long drooping ears.";
            imagex="dog3.gif";
            lookup="basset%20hound";
                    
        } else if(codex.equals("PUG")) {
            name="Pug";
            descr="A small sturdy dog having short hair, a snub nose, wrinkled face and a squarish body";
            imagex="dog4.gif";
            lookup="pug";
        }
        
        out.println("<response>");
        out.println("<name>" + name + "</name>");
        out.println("<description>" + descr + "</description>");
        out.println("<image>../images/" + imagex + "</image>");
        out.println("<link>http://dictionary.reference.com/search?q=" + lookup + "</link>");
        out.println("</response>");
        out.close();
    }
        
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /** Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /** Returns a short description of the servlet.
     */
    public String getServletInfo() {
        return "Short description";
    }
    // </editor-fold>
}
