<%-- Copyright 2004 Sun Microsystems, Inc.  All rights reserved.  You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at: 

 http://developer.sun.com/berkeley_license.html

 $Id: index.jsp,v 1.9 2005/03/30 05:22:16 inder Exp $ --%>



<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h" %>

<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f" %>



<html>

  <head> <title>Handling Command Submissions with JavaServer Faces Home Page</title> </head>

  <body bgcolor="white">

  <h1>Handling Command Submissions with JavaServer Faces Home Page</h1>

  <p>This application illustrates some strategies for

  handling command submissions for applications written using

  JavaServer Faces. In the GUI below,

  <ul>

  <li>The command submission due to

  the pressing of the "Login" button is handled through an

  <i>Action</i> method (<code>login()</code> method of 

  <code>CommandSubmissionBean</code>). </li>

  <li>The command submission due to 

  the pressing of the "Guest Login" method is handled through a static

  action. (the page navigation mapping specified for the "success" 

  outcome for index.jsp).</li>

  <li>The command submission due to 

  the pressing of "Show More Details"/"Hide Details" button is handled 

  through an <i>ActionListener</i> (<code>detailsActionListener</code> 

  method of <code>CommandSubmissionBean</code>). </li>

  </ul></p> 



  <f:view>

  <h:form id="commandsubmissions" >

    <h2>Hello

       <h:outputText value="#{CommandSubmissionsBean.userName}"/>

    </h2>

    <p>

       Enter a user name and password or login as a guest. Only the 

       user <i><h:outputText value="#{CommandSubmissionsBean.allowedUserName}"/></i> with 

       password <i><h:outputText value="#{CommandSubmissionsBean.allowedPassword}"/></i> succeeds. </p>

    	  

    <b>User Name:</b> <h:inputText id="userName" value="#{CommandSubmissionsBean.userName}"/> <br><br>

    <b>Password:</b> <h:inputText id="password" value="#{CommandSubmissionsBean.password}"/> <br><br>

    <h:commandButton id="submit" action="#{CommandSubmissionsBean.login}" value="Login" /> &nbsp;&nbsp;

    <h:commandButton id="guest" action="success" value="Guest Login" /> <br><br>

    <b>Login Status: <h:outputText value="#{CommandSubmissionsBean.authStatus}"/></b>

    <br>

    <p>

    <h:commandButton actionListener="#{CommandSubmissionsBean.detailsActionListener}" id="details" value="Show More Details"/>

    <br><p>

    <h:outputText id="addressText" rendered="false" value="Address: "/>

    <br>

    <h:inputTextarea id="addressTextArea" rendered="false" value="4140 Network Circle, Santa Clara, CA 95054"/>

  </h:form>

  </f:view>

  </body>

</html>  

