<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%--
The taglib directive below imports the JSTL library. If you uncomment it,
you must also add the JSTL library to the project. The Add Library... action
on Libraries node in Projects view can be used to add the JSTL 1.1 library.
--%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %> 
<%@taglib uri="http://java.sun.com/jsf/html" prefix="h" %>
<%@taglib uri="http://java.sun.com/jsf/core" prefix="f" %>
<%@taglib prefix="ui" uri="http://java.sun.com/blueprints/ui/14" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Popup Calendar Sample</title>
    </head>
    <body>
        <h1>Popup Calendar Sample</h1>
        <p>
        The following table shows several examples of the popup calendar
        component. The "localeString" property may be set to a particular
        locale. If not set, then the locale of the view root will be used.
        The default "dateFormatPattern" is determined from the locale but can
        be overridden. Select dates using the popup calendar and press the
        "Submit" button to view the results.
        </p>
        <f:view>
            <h:form>
            <table border="1" cellpadding="5" cellspacing="5">
                <tr>
                    <th>Description</th>
                    <th>Locale</th>
                    <th>Date Format Pattern</th>
                    <th>Select Date</th>
                </tr>
                <tr>
                    <td>Default "localeString" means to use same locale as the view root.<br/>
                        Default "dateFormatPattern" property value is based on localeString.</td>
                    <td>Unspecified (default is null)</td>
                    <td>Unspecified (default is null)</td>
                    <td>
                      <ui:popupCalendar id="cal1" value="#{CalendarBean.date1}"/>
                    </td>
                </tr>
                <tr>
                    <td>Specify dateFormatPattern of ISO date format</td>
                    <td>Unspecified (default is null)</td>
                    <td>yyyy-MM-dd</td>
                    <td>
                      <ui:popupCalendar id="cal2" dateFormatPattern="yyyy-MM-dd" value="#{CalendarBean.date2}"/>
                    </td>
                </tr>
                <tr>
                    <td>Specify localeString with "es", Spanish</td>
                    <td>es</td>
                    <td>Unspecified (default is null)</td>
                    <td>
                      <ui:popupCalendar id="cal3" localeString="es" value="#{CalendarBean.date3}"/>
                    </td>
                </tr>
                <tr>
                    <td>Specify localeString with "zh_CN", Chinese China</td>
                    <td>zh_CN</td>
                    <td>Unspecified (default is null)</td>
                    <td>
                      <ui:popupCalendar id="cal4" localeString="zh_CN" value="#{CalendarBean.date4}"/>
                    </td>
                </tr>
                <tr>
                    <td>Specify localeString with "ja_JP", Japanese Japan</td>
                    <td>ja_JP</td>
                    <td>Unspecified (default is null)</td>
                    <td>
                      <ui:popupCalendar id="cal5" localeString="ja_JP" value="#{CalendarBean.date5}"/>
                    </td>
                </tr>
            </table>
            <h:messages/>
            <h:commandButton action="submitData" value="Submit"/>
            </h:form>
        </f:view>
        <br/><br/><br/>
        <c:if test="${initParam['com.sun.blueprints.LIVE_APPLICATION'] != 'true'}">
            <center>
                This coding example is located in the relative directory <a href="${pageContext.request.contextPath}/faces/index.jsp" target="bpcatalog">
                <i>BPCATALOG_INSTALL_DIR</i>/apps/webtier/bp-popup-calendar</a>
                <br/>
            </center>    
        </c:if>
        <jsp:include page="footer.jsp" />    
    </body>
</html>
