<%-- @@copyright@@ $Id: index.jsp,v 1.5 2005/05/17 05:12:38 gmurray71 Exp $ --%>

<%@ taglib prefix="cs" uri="http://java.sun.com/blueprints/cs" %>
<%@ taglib prefix="c" uri="/WEB-INF/c.tld" %>

</html>
<body>

<h1>ClientSide State</h1>

<p>
This example uses a hidden form variable to save the state of a serializable Java object
in a client page. The contents of the Java object are stored
using the Base64 encoding. The content can also be stored in encrypted
form by setting the <code>secure</code> attribute to <code>true</code> for the
<code>ClientState</code> tag to &quot;true&quot;. 
</p>
<p>
Below is a list of words (initially empty) that is stored in the page
through a Java object serialized in the hidden form variables. When a
form POST is made by pressing the &quot;Update List&quot; button, the Java
object is deserialized and recreated into the request scope with the
id &quot;sampleBean&quot;. The Web application then updates this
object as needed, and writes it back in the encoded form in the HTTP
response page as a hidden form field.
</p>

<cs:client-state action="word" beanName="sampleBean" secure="false">
 <table>
  <c:forEach var="word" varStatus="status" begin="0" items="${sampleBean.words}">
   <tr>
    <td>
     <input type="checkbox" name="word_${status.index}" value="${word}">
      ${word}
     </input>
    </td>
   </tr>
  </c:forEach>
  <tr>
   <td>
    Add a new word: <input type="text" name="newWord" size="25"/>
   </td>
  </tr>
  <tr>
   <td>
    <input type="submit" value="Update List"/>
   </td>
  </tr>
 </table>
</cs:client-state>

<p>
A word can be removed from the list by checking  the checkbox next to
that word. A word can be added by entering it in the textfield next to
the text-label &quot;New Word&quot;
</p>
<p>
To make the changes, click the &quot;Update List&quot; button. Note
that you can navigate through the <i>Back</i> and <i>Forward</i>
buttons of the browser and submissions from any page will result in
the correct response. This is so because the state is being stored in
the page itself, and not in the session. Hence, the server will return
the response based on the page state.
</p>

</body>
</html>
