<%-- Copyright 2006 Sun Microsystems, Inc. All rights reserved. You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at: http://developer.sun.com/berkeley_license.html
$Id: rssbar.jsp,v 1.7 2007/03/08 21:54:21 basler Exp $ --%>

<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>

<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %> 
<%@taglib prefix="f" uri="http://java.sun.com/jsf/core"%>
<%@taglib prefix="h" uri="http://java.sun.com/jsf/html"%>
<%@taglib prefix="ui" uri="http://java.sun.com/blueprints/ui" %>

<html>
    <head>
        <title>RSS Bar demo</title>
    </head>
    <body>
        <h3>RSS Bar demo</h3>
        <p>
            The following ticker shows the first four items in the RSS feed
            obtained from <code>https://blueprints.dev.java.net/servlets/ProjectRSS</code>
            and rotates those items in 3000 millisecond interval. When you click the
            item, it pops up another window to display the actual content of it.
        </p>
        
        <f:view>
            <ui:rssBar url="https://blueprints.dev.java.net/servlets/ProjectRSS?type=news"
                       itemCount="4"
                       title="News from BluePrints"
                       speed="3000"
                       backgroundImage="default"
                       color="#000000" hoverColor="#ff00ff"></ui:rssBar>
        </f:view>
        <br/><br/><br/><br/><br/><br/>
        <c:if test="${initParam['com.sun.blueprints.LIVE_APPLICATION'] != 'true'}">
            <center>
                This coding example is located in the relative directory <a href="${pageContext.request.contextPath}/faces/rssbar.jsp" target="bpcatalog">
                <i>BPCATALOG_INSTALL_DIR</i>/apps/webtier/bp-rss-bar</a>
                <br/>
            </center>    
        </c:if>
        <jsp:include page="footer.jsp" />    
    </body>
</html>